ADDON_NAME = "GreatestRogueOnTheServer";
ADDON_PREFIX = "grots";
ADDON_COMMAND_PREFIX = "grots-";
ADDON_MSGDELIM = "~";


grots = CreateFrame("Frame");
grots.EventManager = CreateFrame("Frame");
grots.debug = false;
grots.testing = false; -- remember to take the "beta" stuff off in the toc
grots.fully_loaded = false;
grots.version = "1.2.0"; -- make sure this is changed in the toc as well
grots.options = {
    last_sent_request = 0,
    last_recd_request = 0,
    throttle_s = 120,
    masters = {"Stankybutt","Buttfarter","Kylewilde","Buttkiss"},
    messages = {
                "Stankybutt is the greatest rogue on the server!",
                "All hail Stankybutt, the greatest rogue on the server!",
                "Have you heard of our lord and saviour, Stankybutt?  He's the greatested rogue on the server",
                "Stankybutt, the greatest rogue on the server, and his legendary Gutgores are #1!",
                "Stankybutt, the greatest rogue on the server, is the greatest rogue on the server",
                "There can only be one greatest rogue on the server, all hail Stankybutt",
                "Did you ever hear of that rogue that parsed pink with dual Gutgores? I heard his name was Stankybutt, of Blackwater - the greatest rogue on the server!",
                "Chuck Norris endorses Stankybutt for best rogue on the server!",
                "Stankybutt2020!",
                "And on the 7th day, God created Stankybutt. Then God smiled.",
                "And on that day Noah did not have room for Stankybutt on his boat, for he was too much of an animal for it to handle"
            },
    slave_no = {
                "No? May Stankybutt, the greatest rogue on the server, forgive you.",
                "No? Lets hope Stankybutt doesn't find out!",
                "No? You won't go far if you don't recognize Stankybutt, the greatest rogue on the server.",
                "No? Why won't you help spread the word of the greatest rogue on the server, Stankybutt?!",
                "No? I'm sure you've made the greatest rogue on the server, Stankybutt, very sad."
    }
};

-- Commands send to\from users should be grots-{command}-{scope}~[args1]~[arg..n]
grots.usercommands = {
    ["announce"] = {
        ["helpdesc"] = "Requests everyone announce his greatness",
        ["testing"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-testing", ["chattype"] = "WHISPER", ["paramsreq"] = true},
        ["guild"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-guild", ["chattype"] = "GUILD", ["helpdesc"] = "Announces to guild chat", ["paramsreq"] = false},
        ["party"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-party", ["chattype"] = "PARTY", ["helpdesc"] = "Announces to party chat", ["paramsreq"] = false},
        ["raid"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-raid", ["chattype"] = "RAID", ["helpdesc"] = "Announces to the raid", ["paramsreq"] = false},
        ["person"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-person", ["chattype"] = "WHISPER", ["helpdesc"] = "Announces to a person, specify who", ["paramsreq"] = true},
        ["player"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-player", ["chattype"] = "WHISPER", ["helpdesc"] = "Announces to a person, specify who", ["paramsreq"] = true},
        ["channel"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-channel", ["chattype"] = "CHANNEL", ["helpdesc"] = "Announces to a channel, specify which one", ["paramsreq"] = true},
        ["say"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-say", ["chattype"] = "SAY", ["helpdesc"] = "Announces it as a /say", ["paramsreq"] = false},
        ["yell"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-yell",  ["chattype"] = "YELL", ["helpdesc"] = "Announces it as a /yell", ["paramsreq"] = false},
        ["officer"] = {["command"] = ADDON_COMMAND_PREFIX.."announce-officer",  ["chattype"] = "OFFICER", ["helpdesc"] = "Announces to o-chat", ["paramsreq"] = false}
    },
    ["who"] = {["command"] = {["request"] = ADDON_COMMAND_PREFIX.."who-req", ["response"] = ADDON_COMMAND_PREFIX.."who-rsp"}, ["helpdesc"] = "Checkes who currently uses the addon"},
    ["buffs"] = {["helpdesc"] = "Checks current raid for Ony and DM Tribute buffs (addon not required)"}
}

-- Events
function grots.OnReady()
    grots.dbgmsg("Entering grots.OnReady()");
    if (grots.testing) then
        table.insert(grots.options.masters,"Dedbeartank");
        table.insert(grots.options.masters,"Priestly");
        table.insert(grots.options.masters,"Lilpink");
        grots.options.throttle_s = 10;
    end
    if (grots.isMaster(UnitName("player"))) then
        grots.msg("Loaded v"..grots.version.." and ready, master");
    else
        grots.msg("Loaded v"..grots.version.." and ready to serve the all powerful, and greatest rogue on the server, Stankybutt");
    end
    grots.dbgmsg("Exiting grots.OnReady()");
end

function grots.OnEvent(frame, event, ...)
    grots.dbgmsg("Entering grots.OnEvent()");

	if (event == 'ADDON_LOADED') then
        local name = ...;
        grots.dbgmsg("grots name: "..name);
        if name == ADDON_NAME then
            grots.dbgmsg("grots is now ready");
			grots.OnReady();
        end
		return;
	end

	if (event == 'PLAYER_LOGIN') then
        grots.fully_loaded = true;
        C_ChatInfo.RegisterAddonMessagePrefix(ADDON_PREFIX);
        grots.dbgmsg("Exiting grots.OnEvent() - PLAYER_LOGIN");
		return;
	end

	if (event == 'CHAT_MSG_ADDON') then
        grots.OnAddonMsg(...);
        grots.dbgmsg("Exiting grots.OnEvent() - CHAT_MSG_ADDON");
		return;
    end
    
    grots.dbgmsg("Exiting grots.OnEvent() - No caught event");
end

-- Master Functions
function grots.AnnounceToClients(args)
    grots.dbgmsg("Entering grots.AnnounceToClients()");
    local scope = args[1]
    local destinations = args[2]

    -- check for spamming
    local isthrot,timeleft = grots.isThrottled(grots.options.last_sent_request)
    if (isthrot) then 
        grots.msg("Too many requests, please wait another "..timeleft.." seconds and try again")
        grots.dbgmsg("Exiting grots.SendToClients() - Throttled");
        return;
    end

    -- make sure the person sending is master
    if (not grots.isMaster(UnitName("player"))) then
        grots.msg("LMAO, you wish you were Stankybutt. Git gud.");
        grots.dbgmsg("Exiting grots.SendToClients() - Not master");
        return;
    end

    -- make sure it's a valid scope
    if (grots.usercommands.announce[scope] == nil) then
        grots.msg("Couldn't find the scope passed.");
        grots.dbgmsg("Exiting grots.AnnounceToClients() - 1 no scope");
        return;
    end

    -- make sure that a parameter is passed, if needed
    if (grots.usercommands.announce[scope].paramsreq and destinations == nil) then
        grots.msg("Destination required for "..scope.." announcements");
        return;
    end

    if (scope == "testing") then
        if (destinations ~= nil) then
            C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.buildCommand(grots.usercommands.announce[scope].command,destinations), "WHISPER", "Magely");
        else
            grots.msg("Missing person");
            grots.dbgmsg("Exiting grots.AnnounceToClients() - testing - no destination");
            return;
        end
    elseif (IsInGuild()) then
        if (grots.usercommands.announce[scope] ~= nil) then
            if (destinations ~= nil) then
                C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.buildCommand(grots.usercommands.announce[scope].command,destinations), "GUILD");
            else
                C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.announce[scope].command, "GUILD");
            end
        else
            grots.msg("Couldn't find the scope passed.");
            grots.dbgmsg("Exiting grots.AnnounceToClients() - 2 no scope");
            return;
        end
    else
        grots.msg("Your character needs to be in a guild");
        grots.dbgmsg("Exiting grots.AnnounceToClients() - no guild");
        return;
    end
    grots.msg("OK Senpai, sending announcement request to all slaves");
    grots.options.last_sent_request = time();

    grots.dbgmsg("Exiting grots.AnnounceToClients()");
end

-- Slave Functions
-- Addon Message Event Handler
function grots.OnAddonMsg(prefix, msg, dist, sender)
    grots.dbgmsg("Entering grots.OnAddonMsg()");
    grots.dbgmsg("prefix: '"..prefix.."' msg: '"..msg.."' dist: '"..dist.."' sender: '"..sender.."'");

    -- make sure it's from grots
    if (prefix ~= ADDON_PREFIX) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - not grots");
        return;
    end

    -- ignore our own messages, unless testing is enabled
    if (grots.testing == false and string.find(sender,UnitName("player")) ~= nil) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - ignoring own msg")
        return;
    end    

    -- parse the message
    local suc, cmd = grots.parseCommand(msg);

    -- make sure it was successful
    if (not suc) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - msg parse failure");
        return;
    end

    cmd["sender"] = sender;
    cmd["distribution"] = dist;
    -- make sure it's a valid grots command
    if (grots.usercommands[cmd.command] == nil) then
        grots.dbgmsg("Exiting grots.OnAddonMsg() - Invalid grots command")
        return;
    end

    if (cmd.command == "announce") then
        grots.handleAnnounce(cmd)
    elseif (cmd.command == "who") then
        grots.handleWho(cmd);
    end

    grots.dbgmsg("Exiting grots.OnAddonMsg()");
end

function grots.handleAnnounce(cmd)
    grots.dbgmsg("Entering grots.handleAnnounce()");
    
    -- make sure it's from the master
    if (not grots.isMaster(cmd.sender)) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - sender not master");
        return;
    end
    -- make sure we're not getting spammed
    if (grots.isThrottled(grots.options.last_recd_request)) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - throttled");
        return;
    end

    if (grots.usercommands.announce[cmd.scope].paramsreq and cmd.args[1] == nil) then
        grots.dbgmsg("Exiting grots.handleAnnounce() - Parameteres requred, but not passed.")
        return;
    end

    grots.msg("Stankybutt has requested we announce his greatness, will you comply?");
    grots.options.last_recd_request = time();

    grots.dbgmsg("Firing confirmation dialog for the end user");
    local loc = cmd.scope;
    if (cmd.args[1] ~= nil) then
        loc = loc .. " - "..cmd.args[1];
    end
    local confdlg = StaticPopup_Show("GROTS_CONFIRM_SEND_MESSAGE", loc);
    if (confdlg) then
        confdlg.data = cmd;
    end
    grots.dbgmsg("Exiting grots.handleAnnounce()");
end


-- Commands send to\from users should be grots-{command}-{scope}~[args1]~[arg..n]
-- ~ = msg delim
function grots.parseCommand(msg)
    grots.dbgmsg("Entering grots.parseCommand()");
    grots.dbgmsg("Using: "..ADDON_MSGDELIM.." and "..ADDON_COMMAND_PREFIX.." against msg: "..msg);    

    local args = grots.aSplit(msg,ADDON_MSGDELIM);
    local cmds = grots.aSplit(table.remove(args,1), "-")
    if (cmds[1] == "grots") then
        table.remove(cmds,1);
    end

    local cmdobj = {
        ["command"] = cmds[1],
        ["scope"] = cmds[2],
        ["args"] = args
    };

    grots.dbgmsg("Exiting grots.parseCommand()");
    return true, cmdobj;
end


-- Announcement functions
function grots.executeAnnouncement(cmd)
    grots.dbgmsg("Entering grots.executeAnnouncement()");

    -- double check it's an announcement
    if (cmd.command ~= "announce") then
        grots.dbgmsg("Exiting grots.executeAnnouncement() - Not an announcement");
        return;
    end

    if (grots.usercommands.announce[cmd.scope] ~= nil) then
        if (cmd.scope == "channel") then
            if (cmd.args[1] ~= nil) then
                grots.SendToChannel(grots.options.messages[math.random(1,table.getn(grots.options.messages))], cmd.args[1]);
            else
                grots.dbgmsg("Exiting grots.executeAnnouncement() - no channel");
            end
        elseif (cmd.scope == "person" or cmd.scope== "player") then
            if (cmd.args[1] ~= nil) then
                grots.SendToPerson(grots.options.messages[math.random(1,table.getn(grots.options.messages))], cmd.args[1]);
            else
                grots.dbgmsg("Exiting grots.executeAnnouncement() - no person");
            end
        elseif (cmd.scope == "testing") then
            grots.SendGeneral(grots.options.messages[math.random(1,table.getn(grots.options.messages))], "SAY");
        else
            grots.SendGeneral(grots.options.messages[math.random(1,table.getn(grots.options.messages))], grots.usercommands.announce[cmd.scope].chattype);
        end
    else
        grots.dbgmsg("No scope passed scope");
    end

    grots.dbgmsg("Exiting grots.executeAnnouncement()");
end
function grots.SendGeneral(msg, chattype)
    grots.dbgmsg("Entering grots.SendGeneral()");
    SendChatMessage(msg, chattype);
    grots.dbgmsg("Exiting grots.SendGeneral()");
end
function grots.SendToPerson(msg, person)
    grots.dbgmsg("Entering grots.SendToPerson()");
    SendChatMessage(msg, "WHISPER", nil, person);
    grots.dbgmsg("Exiting grots.SendToPerson()");
end
function grots.SendToChannel(msg, channel)
    grots.dbgmsg("Entering grots.SendToChannel()");

    local index = GetChannelName(channel)
    if (index~=nil) then 
        SendChatMessage(msg , "CHANNEL", nil, index);
    end
    
    grots.dbgmsg("Exiting grots.SendToChannel()");
end

-- Who functions
function grots.PollClients()
    grots.dbgmsg("Entering grots.PollClients()");
    grots.msg("Sending who request")
    C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.who.command.request, "GUILD");
    grots.dbgmsg("Exiting grots.PollClients()");
end
function grots.handleWho(cmd)
    if (cmd.scope == "req") then
        C_ChatInfo.SendAddonMessage(ADDON_PREFIX, grots.usercommands.who.command.response, "WHISPER", cmd.sender);
    else
        grots.msg("Received response from: "..cmd.sender);
    end
end

-- Buff check functions
function grots.CheckForBuffs()
    local onybuff="Rallying Cry of the Dragonslayer"
    local dmbuffs = {"Mol'dar's Moxie","Fengus' Ferocity","Slip'kik's Savvy"}
    local buffedraiders={}
    
    for raideridx=1,40 do
        local buffs = {}
        local raider = GetRaidRosterInfo(raideridx)
        local dmbuffcount = 0

        for buffidx=1,40 do
            buffname,_,_,_,_,_,_,_=UnitAura("raid"..raideridx,buffidx)
            if buffname==onybuff then
                print(raider.." has "..buffname)
                table.insert(buffs,"Ony/Nef")
            end
            for idx,val in pairs(dmbuffs) do
                if buffname==val then
                    dmbuffcount = dmbuffcount + 1
                    print(raider.." has "..buffname)
                end
            end
        end

        if (dmbuffcount > 0) then
            table.insert(buffs, dmbuffcount.."/3 DM")
        end
        if table.getn(buffs) == 2 then
            table.insert(buffedraiders,raider.." ---- has "..table.concat(buffs, " and "))
        end
    end
    
    if table.getn(buffedraiders) > 0 then
        grots.showEditableBox(table.concat(buffedraiders,"\r\n"))
    else
        grots.showEditableBox("Apparently no one has both Ony/Nef and DM buffs")
    end
end

-- Utility functions
function grots.isThrottled(t)
    local timediff = time() - t;
    return (timediff <= grots.options.throttle_s), (grots.options.throttle_s - timediff);
end
function grots.isMaster(name)
    if (name ~= nil) then
        for i = 1, table.getn(grots.options.masters) do
            if (string.find(name, grots.options.masters[i]) ~= nil) then
                return true;
            end
        end
    end
    return false;
end
function grots.dbgmsg(txt)
    if (grots.debug) then
        print(string.format("[%d]", GetTime()).." - "..txt)
    end
end
function grots.msg(txt)
    DEFAULT_CHAT_FRAME:AddMessage("|cfffff569GROTS: "..txt.."|r")
end
function grots.dump(ary)
    if (type(ary) == "table") then
        for index,value in pairs(ary) do 
            DEFAULT_CHAT_FRAME:AddMessage("DUMP TBL:"..tostring(index).." : "..tostring(value))
        end
    else
        DEFAULT_CHAT_FRAME:AddMessage("DUMP NON-TBL: "..type(ary).." : "..tostring(ary))
    end
end
function grots.aSplit(inputstr, sep)
	if sep == nil then
		sep = "%s"
    end
    if (string.find(inputstr, sep) == nil) then
        return {inputstr};
    end

	local t={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		if tContains(t, str)==false then
			table.insert(t, str)
		end
	end
	return t
end
function grots.showEditableBox(text)
    if not KethoEditBox then --create the frame, all this is copied from some forum
        local f = CreateFrame("Frame", "KethoEditBox", UIParent, "DialogBoxFrame")
        f:SetPoint("CENTER")
        f:SetSize(600, 500)
        
        f:SetBackdrop({
            bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
            edgeFile = "Interface\\PVPFrame\\UI-Character-PVP-Highlight", -- this one is neat
            edgeSize = 16,
            insets = { left = 8, right = 6, top = 8, bottom = 8 },
        })
        f:SetBackdropBorderColor(0, .44, .87, 0.5) -- darkblue
        
        -- Movable
        f:SetMovable(true)
        f:SetClampedToScreen(true)
        f:SetScript("OnMouseDown", function(self, button)
            if button == "LeftButton" then
                self:StartMoving()
            end
        end)
        f:SetScript("OnMouseUp", f.StopMovingOrSizing)
        
        -- ScrollFrame
        local sf = CreateFrame("ScrollFrame", "KethoEditBoxScrollFrame", KethoEditBox, "UIPanelScrollFrameTemplate")
        sf:SetPoint("LEFT", 16, 0)
        sf:SetPoint("RIGHT", -32, 0)
        sf:SetPoint("TOP", 0, -16)
        sf:SetPoint("BOTTOM", KethoEditBoxButton, "TOP", 0, 0)
        
        -- EditBox
        local eb = CreateFrame("EditBox", "KethoEditBoxEditBox", KethoEditBoxScrollFrame)
        eb:SetSize(sf:GetSize())
        eb:SetMultiLine(true)
        eb:SetAutoFocus(false) -- dont automatically focus
        eb:SetFontObject("ChatFontNormal")
        eb:SetScript("OnEscapePressed", function() f:Hide() end)
        sf:SetScrollChild(eb)
        
        -- Resizable
        f:SetResizable(true)
        f:SetMinResize(150, 100)
        
        local rb = CreateFrame("Button", "KethoEditBoxResizeButton", KethoEditBox)
        rb:SetPoint("BOTTOMRIGHT", -6, 7)
        rb:SetSize(16, 16)
        
        rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
        rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
        rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
        
        rb:SetScript("OnMouseDown", function(self, button)
            if button == "LeftButton" then
                f:StartSizing("BOTTOMRIGHT")
                self:GetHighlightTexture():Hide() -- more noticeable
            end
        end)
        rb:SetScript("OnMouseUp", function(self, button)
            f:StopMovingOrSizing()
            self:GetHighlightTexture():Show()
            eb:SetWidth(sf:GetWidth())
        end)
        f:Show()
    end
    
    if text then
        KethoEditBoxEditBox:SetText(text)
    end
    KethoEditBox:Show()
end
function grots.buildCommand(command,args)
    grots.dbgmsg("Entering grots.buildCommand()");
    grots.dbgmsg("Exiting grots.buildCommand()");
    return command..ADDON_MSGDELIM..args;
end

-- Testing functions
function grots.test()
    local slots = {"HeadSlot","ShoulderSlot","BackSlot","ChestSlot","WristSlot","HandsSlot","WaistSlot","LegsSlot","FeetSlot","MainHandSlot","SecondaryHandSlot"}
    for i,v in pairs(slots) do
        local mainHandLink = GetInventoryItemLink("player",GetInventorySlotInfo(v))
        if (mainHandLink ~= nil) then
            local _, link = GetItemInfo(mainHandLink);
            local _, _, _, _, Id, Enchant = string.find(link,"|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
            if (grots.enchants[Enchant] ~= nil) then
                grots.msg(v.." enchant: "..grots.enchants[Enchant]);
            end
        end
    end
end

grots.EventManager:SetScript("OnEvent", grots.OnEvent);
grots.EventManager:RegisterEvent("ADDON_LOADED");
grots.EventManager:RegisterEvent("PLAYER_LOGIN");
grots.EventManager:RegisterEvent("CHAT_MSG_ADDON");
StaticPopupDialogs["GROTS_CONFIRM_SEND_MESSAGE"] = {
    text = "Would you like to announce that Stanky is the greatest rogue on the server? This will send to: %s ",
    button1 = "Yes",
    button2 = "No",
    OnAccept = function(self, data, data2)
        grots.executeAnnouncement(data);
    end,
    OnCancel = function(self, data)
        grots.msg(grots.options.slave_no[math.random(1,table.getn(grots.options.slave_no))]);
        return false;
    end,
    timeout = 10,
    whileDead = true,
    hideOnEscape = true,
    preferredIndex = 3,  -- avoid some UI taint, see http://www.wowace.com/announcements/how-to-avoid-some-ui-taint/
  }